/*------------------------------------------------------------------------------
* Copyright (C) 2003-2006 Ben van Klinken and the CLucene Team
* 
* Distributable under the terms of either the Apache License (Version 2.0) or 
* the GNU Lesser General Public License, as specified in the COPYING file.
------------------------------------------------------------------------------*/
#pragma once

#include "CLucene/util/VoidMap.h"
#include "CLucene/util/Reader.h"
#include "CLucene/analysis/AnalysisHeader.h"
#include "CLucene/analysis/Analyzers.h"
#include "CLucene/analysis/standard/StandardFilter.h"
//#include "CLucene/analysis/standard/StandardTokenizer.h"
//#include "CJKTokenizer.h"

CL_NS_DEF2(analysis,cjk)

	class CJKAnalyzer : public Analyzer 
	{
	private:
		CL_NS(util)::CLSetList<const TCHAR*> stopSet;
	public:
		// <summary> Builds an analyzer. </summary>
		CJKAnalyzer();

		//<summary> Builds an analyzer with the given stop words. </summary>
		CJKAnalyzer( const TCHAR** stopWords);

		~CJKAnalyzer();


		// <summary>
		// Constructs a StandardTokenizer filtered by a 
		// StandardFilter, a LowerCaseFilter and a StopFilter.
		// </summary>
		TokenStream* tokenStream(const TCHAR* fieldName, CL_NS(util)::Reader* reader) 
		;
	};
CL_NS_END2

